#include "Array.h"

int IsSorted(TArray *pA)
{
	int i;
	for(i=0;i<pA->Size-1;i++)
		if (pA->Positions[i].key > pA->Positions[i+1].key)
			return i;
	return -1;
}

void Allocate(TArray *pA,int size)
{
	pA->Size = size;
	pA->Positions = (TItem*)calloc(size,sizeof(TItem));
}

void GenerateRandomNoRep(TArray *pA,int max)
{
	int i,aux;
	long pos1,pos2;

	for(i=0;i<pA->Size;i++)
			pA->Positions[i].key = i;
	srand(time(NULL));
	for(i=0;i<(pA->Size);i++)
	{
		pos1 = ((long)rand()*rand())%max;
		pos2 = ((long)rand()*rand())%max;
		aux= pA->Positions[pos2].key;
		pA->Positions[pos2].key = pA->Positions[pos1].key;
		pA->Positions[pos1].key = aux;
	}
}

void GenerateRandom(TArray *pA,int max)
{
	int i;
	srand(time(NULL));
	for(i=0;i<pA->Size;i++)
		pA->Positions[i].key = ((long)rand()*rand())%max;
}

void GenerateInvert(TArray *pA,int max)
{
	int i;
	for(i=0;i<pA->Size;i++)
		pA->Positions[i].key = (int) ((max-((double)i/pA->Size)*max)-1);
}

void GenerateAlmostSorted(TArray *pA,int max)
{
	int i;
	for(i=0;i<(9*pA->Size)/10;i++)
		pA->Positions[i].key = (int) (((double)i/pA->Size)*max);
	srand(time(NULL));
	for(;i<pA->Size;i++)
		pA->Positions[i].key = rand()%max;
}

void GenerateAlmostSortedNoRep(TArray *pA,int max)
{
	int i,aux,pos1,pos2;
	for(i=0;i<pA->Size;i++)
			pA->Positions[i].key = i;
	srand(time(NULL));
	for(i=0;i<(pA->Size*0.1);i++)
	{
		pos1 = rand()%max;
		pos2 = rand()%max;
		aux= pA->Positions[pos2].key;
		pA->Positions[pos2].key = pA->Positions[pos1].key;
		pA->Positions[pos1].key = aux;
	}
}

void GenerateSorted(TArray *pA,int max)
{
	int i;
	for(i=0;i<pA->Size;i++)
		pA->Positions[i].key = (int)(((double)i/pA->Size)*max);
}

void Copy(TArray *pA,TArray *pCopy,int init,int end,int *NAt, int *NComp)
{
	int i,j=init;
	if(pA->Size >= pCopy->Size)
		if(pCopy->Positions!=NULL)
			for(i=0;i<pA->Size&&j<end+1;i++,j++)
			{
				pCopy->Positions[i]=pA->Positions[j];(*NAt)++;
			}
		
}
void Print(TArray *pA)
{
	int i;
	printf("\nArray:\n");
	for(i=0;i<pA->Size;i++)
		printf("%d - ",pA->Positions[i].key);
	printf("\n");
}
void FreeArray(TArray *pA)
{
	if (pA->Positions != NULL)
		free(pA->Positions);
	pA->Positions = NULL;
	pA->Size = 0;
}

void qMakeEmpty(TQueue* pBucket)
{
	while(!qIsEmpty(pBucket))
	{
		qDequeue(pBucket,NULL);
	}
	if(pBucket->pLast != NULL && pBucket->pFirst != NULL)
		free(pBucket->pLast);
	pBucket->pFirst = (Pointer)malloc(sizeof(TCell));
	if(pBucket->pFirst == NULL)
	{
		printf("Error\n");
		exit(1);
	}
	pBucket->pLast = pBucket->pFirst;
}

int qIsEmpty(TQueue* pBucket)
{
	if((pBucket->pFirst == pBucket->pLast) ||
		(pBucket->pFirst == NULL) || (pBucket->pLast == NULL))
		return 1;
	return 0;
}

void qEnqueue(TQueue* pBucket, TItem pItem)
{
	Pointer Aux;
	Aux = (Pointer)malloc(sizeof(TCell));
	if(Aux == NULL)
	{
		printf("Error\n");
		exit(1);
	}
	pBucket->pLast->pBack = Aux;
	pBucket->pLast->Reg = pItem;
	pBucket->pLast = Aux;
	pBucket->pLast->pBack = NULL;
}

void qDequeue(TQueue* pBucket, TItem* pItem)
{
	Pointer Aux;
	if(qIsEmpty(pBucket))
	{
		pItem = NULL;
		return;
	}
	Aux = pBucket->pFirst;
	*pItem = pBucket->pFirst->Reg;
	pBucket->pFirst = pBucket->pFirst->pBack;
	free(Aux);
}
