#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <math.h>

#include "StopWatch.h"

#define SIZE 100

typedef struct
{
	int key;
}TItem;

typedef struct
{
	TItem* Positions;
	int Size;
}TArray;

typedef struct Cell* Pointer;

typedef struct Cell
{
	TItem Reg;	
	Pointer pBack;		
}TCell;

typedef struct
{
	Pointer pFirst;
	Pointer pLast;
	int Size;
}TQueue;

typedef struct
{
	TQueue *Bucket;
}TBucket;

int  IsSorted(TArray*);
void Allocate(TArray*,int size);
void GenerateRandom(TArray*,int max);
void GenerateRandomNoRep(TArray*,int max);
void GenerateInvert(TArray*,int max);
void GenerateAlmostSorted(TArray*,int max);
void GenerateAlmostSortedNoRep(TArray*,int max);
void GenerateSorted(TArray*,int max);
void Copy(TArray*,TArray*,int,int,int*,int*);
void Print(TArray*);
void FreeArray(TArray*);
void qMakeEmpty(TQueue*);

int qIsEmpty(TQueue*);
void qEnqueue(TQueue*, TItem);
void qDequeue(TQueue*, TItem*);
void qfreeQueue(TQueue*);
