#include "Sort.h"
#include "PilhaAD.h"

// QuickSort
void Partition(int left,int right,int *i,int *j,TArray *pA,int *NAt, int *NComp)
{
	TItem pivot,Aux;

	*i=left;*j=right;

	(*NComp)+=4;
	if (((pA->Positions[left].key > pA->Positions[right].key) && (pA->Positions[left].key < pA->Positions[(right+left)/2].key)) ||
		((pA->Positions[left].key < pA->Positions[right].key) && (pA->Positions[left].key > pA->Positions[(right+left)/2].key)))
	{
		pivot = pA->Positions[left];(*NAt)++;
	}
	else
	{
		(*NComp)+=4;
		if(((pA->Positions[left].key < pA->Positions[right].key) && (pA->Positions[right].key < pA->Positions[(right+left)/2].key)) ||
		   ((pA->Positions[left].key > pA->Positions[right].key) && (pA->Positions[right].key > pA->Positions[(right+left)/2].key)))
		{
			pivot = pA->Positions[right];(*NAt)++;
		}
		else
		{
			pivot = pA->Positions[(right+left)/2];(*NAt)++;
		}
	}

	do
	{
		while(pivot.key>pA->Positions[*i].key)
		{
			(*NComp)++;
			(*i)++;
		}
		while(pivot.key<pA->Positions[*j].key)
		{
			(*NComp)++;
			(*j)--;
		}
		if(*i<=*j)
		{
			Aux=pA->Positions[*i];(*NAt)++;
			pA->Positions[*i]=pA->Positions[*j];(*NAt)++;
			pA->Positions[*j]=Aux;(*NAt)++;
			(*i)++;
			(*j)--;
		}
	}while(*i<=*j);
}

void Sort(int left,int right,TArray *pA,int *NAt, int *NComp)
{
	int i,j;
	Partition(left,right, &i, &j,pA,NAt,NComp);
	if(left<j)
		Sort(left,j,pA,NAt,NComp);
	if(i<right)
		Sort(i,right,pA,NAt,NComp);
}

void QuickSort(TArray *pA,int *NAt, int *NComp)
{
	Sort(0,pA->Size-1,pA,NAt,NComp);
}


// QuickSortO
void QuickSortO(TArray *pA,int *NAt, int *NComp)
{
	int i,j;
	TPilha Stack;
	TItemPAD limits,limitsAux;
	int MaxStack = (int) (2.*(log(pA->Size)/log(2)) ) ;

	FPVazia(&Stack,MaxStack);

	limits.left  = 0;
	limits.right = pA->Size-1;

	while(1)
	{
		if ( (limits.right - limits.left+1) > 20)
		{
			// Partition
			TItem pivot,Aux;
			i=limits.left;j=limits.right;
			(*NComp)+=4;
			if (((pA->Positions[limits.left].key > pA->Positions[limits.right].key) && (pA->Positions[limits.left].key < pA->Positions[(limits.right+limits.left)/2].key)) ||
				((pA->Positions[limits.left].key < pA->Positions[limits.right].key) && (pA->Positions[limits.left].key > pA->Positions[(limits.right+limits.left)/2].key)))
			{
				pivot = pA->Positions[limits.left];(*NAt)++;
			}
			else
			{
				(*NComp)+=4;
				if(((pA->Positions[limits.left].key < pA->Positions[limits.right].key) && (pA->Positions[limits.right].key < pA->Positions[(limits.right+limits.left)/2].key)) ||
				   ((pA->Positions[limits.left].key > pA->Positions[limits.right].key) && (pA->Positions[limits.right].key > pA->Positions[(limits.right+limits.left)/2].key)))
				{
					pivot = pA->Positions[limits.right];(*NAt)++;
				}
				else
				{
					pivot = pA->Positions[(limits.right+limits.left)/2];(*NAt)++;
				}
			}

			do
			{
				while(pivot.key>pA->Positions[i].key)
				{
					(*NComp)++;
					i++;
				}
				while(pivot.key<pA->Positions[j].key)
				{
					(*NComp)++;
					j--;
				}
				if(i<=j)
				{
					Aux=pA->Positions[i];(*NAt)++;
					pA->Positions[i]=pA->Positions[j];(*NAt)++;
					pA->Positions[j]=Aux;(*NAt)++;
					i++;
					j--;
				}
			}while(i<=j);
			// Partition

			if ( limits.left < j )
			{
				if ( i < limits.right)
				{
					limitsAux.left = i;
					limitsAux.right = limits.right;
					PEmpilha(&Stack,&limitsAux);
				}
	//			limits.left  = limits.left;
				limits.right = j;
			}
			else if ( i < limits.right)
			{
				limits.left  = i;
	//			limits.right = limits.right;
			}
			else
			{
				if (!PEhVazia(&Stack))
					PDesempilha(&Stack,&limits);
				else
					break;
			}
		}
		else
		{
			// SelectSort
			int Min;
			TItem aux;
			for (i = limits.left; i < limits.right; i++)
			{ 
				Min = i;
				for (j = i + 1 ; j <= limits.right; j++)
				{
					(*NComp)++;
					if ( pA->Positions[j].key < pA->Positions[Min].key) 
						Min = j;
				}
				aux = pA->Positions[Min]; (*NAt)++;
				pA->Positions[Min] = pA->Positions[i]; (*NAt)++;
				pA->Positions[i] = aux; (*NAt)++;
			}
			if (!PEhVazia(&Stack))
				PDesempilha(&Stack,&limits);
			else
				break;
		}
	}
	PLibera(&Stack);
}


// HeapSort
void  RemakeHeap(int left, int right, TArray *pA,int *NAt, int *NComp)
{ 
	int i = left, j;
	TItem aux;
	j = i * 2 + 1;
	aux = pA->Positions[i];(*NAt)++;
	while (j <= right)
	{ 
		if (j < right)
		{
			(*NComp)++;
			if (pA->Positions[j].key < pA->Positions[j+1].key) 
			j++; 
		}
		(*NComp)++;
		if (aux.key >= pA->Positions[j].key) 
			break;
		pA->Positions[i] = pA->Positions[j];(*NAt)++;
		i = j;
		j = i * 2 + 1 ;
	}
	pA->Positions[i] = aux;(*NAt)++;
}

void MakeHeap(TArray *pA,int *NAt, int *NComp)
{ 
	int left;
	left = pA->Size / 2;
	while (left >= 0)
	{ 
		RemakeHeap(left, pA->Size-1, pA,NAt, NComp);
		left--;
	}
}

void HeapSort(TArray *pA,int *NAt, int *NComp)
{
	int left, right;
	TItem aux;
	MakeHeap(pA,NAt,NComp);
	left = 0; right = pA->Size-1;
	while (right >= 0)
	{
		aux = pA->Positions[0];(*NAt)++;
		pA->Positions[0] = pA->Positions[right];(*NAt)++;
		pA->Positions[right--] = aux;(*NAt)++;
		RemakeHeap(left,right,pA,NAt,NComp);
	}
}

// HeapSortO
void HeapSortO(TArray *pA,int *NAt, int *NComp)
{
	int i,j;
	int left, right;
	TItem aux;
	// MakeHeap
	left = pA->Size / 2;
	right = pA->Size-1;
	while (left >= 0)
	{ 
		// RemakeHeap
		i = left;
		j = i * 2 + 1;
		aux = pA->Positions[i];(*NAt)++;
		while (j <= right)
		{ 
			if (j < right)
			{
				(*NComp)++;
				if (pA->Positions[j].key < pA->Positions[j+1].key) 
				j++; 
			}
			(*NComp)++;
			if (aux.key >= pA->Positions[j].key) 
				break;
			pA->Positions[i] = pA->Positions[j];(*NAt)++;
			i = j;
			j = i * 2 + 1 ;
		}
		pA->Positions[i] = aux;(*NAt)++;
		// RemakeHeap
		left--;
	}
	// MakeHeap

	left = 0; right = pA->Size-1;
	while (right >= 0)
	{
		aux = pA->Positions[0];(*NAt)++;
		pA->Positions[0] = pA->Positions[right];(*NAt)++;
		pA->Positions[right--] = aux;(*NAt)++;
		// RemakeHeap
		i = left;
		j = i * 2 + 1;
		aux = pA->Positions[i];(*NAt)++;
		while (j <= right)
		{ 
			if (j < right)
			{
				(*NComp)++;
				if (pA->Positions[j].key < pA->Positions[j+1].key) 
				j++; 
			}
			(*NComp)++;
			if (aux.key >= pA->Positions[j].key) 
				break;
			pA->Positions[i] = pA->Positions[j];(*NAt)++;
			i = j;
			j = i * 2 + 1 ;
		}
		pA->Positions[i] = aux;(*NAt)++;
		// RemakeHeap
	}
}



// MergeSort
void Merge(TArray *pA,TArray *pAux,int init1,int end1,int init2,int end2,int *NAt, int *NComp)
{
	int i, j, k;
	FreeArray(pAux);
	Allocate(pAux,end2-init1+1);
	Copy(pA,pAux,init1,end2,NAt,NComp);	
	for (i = 0, j = end1-init1+1, k = init1; k <= end2; k++)
	{
		if ( i == end1-init1+1 ) 
		{ 
			pA->Positions[k] = pAux->Positions[j++]; (*NAt)++;
			continue; 
		}
		if ( j == end2-init2+end1-init1+2 ) 
		{ 
			pA->Positions[k] = pAux->Positions[i++];(*NAt)++; 
			continue; 
		}
		(*NComp)++;
		if ( pAux->Positions[i].key < pAux->Positions[j].key )
		{
			pA->Positions[k] = pAux->Positions[i++];(*NAt)++;
		}
		else
		{
			pA->Positions[k] = pAux->Positions[j++];(*NAt)++;
		}
	}
	FreeArray(pAux);
}

void MSDivide(TArray *pA,TArray* pAux,int init,int end,int *NAt, int *NComp)
{
	int mid; 
	if  (end == init)  
	   return;
	
	mid = (init + end)/ 2;
	MSDivide(pA,pAux, init, mid ,NAt,NComp);
	MSDivide(pA,pAux, mid+1, end,NAt,NComp);
	Merge(pA,pAux, init, mid,mid+1, end,NAt,NComp);
}

void MergeSort(TArray *pA,int *NAt, int *NComp)
{
	TArray* pAux;
	pAux = (TArray*) malloc(sizeof(TArray));

	Allocate(pAux,pA->Size);
	MSDivide(pA,pAux,0,pA->Size-1,NAt,NComp);
	FreeArray(pAux);

	free(pAux);
}

// MergeSortO
void MergeSortO(TArray *pA,int *NAt, int *NComp)
{
	TItem *VAux,*pVAux;
	int l1,l2,u1,u2,size,n;
	int i,j,k;

	n = pA->Size;
	size=1;
	VAux = (TItem*) malloc(sizeof(TItem)*n);
	while(size<n)
	{
		l1=0;
		k=0;
		while(l1+size < n )
		{
			l2=l1+size;
			u1=l2-1;

			if (l2+size-1<n)
				u2 = l2+size-1;
			else
				u2 = n-1;
			// merge
			for( i = l1 , j = l2 ; i <= u1 && j <= u2 ; k++ )
			{
				(*NComp)++;
				if(pA->Positions[i].key<=pA->Positions[j].key)
				{	VAux[k] = pA->Positions[i++]; (*NAt)++;}
				else
				{	VAux[k] = pA->Positions[j++]; (*NAt)++;}
			}
			for(; i <= u1 ; k++ )
			{	VAux[k] = pA->Positions[i++]; (*NAt)++;}
			for(; j <= u2 ; k++ )
			{	VAux[k] = pA->Positions[j++]; (*NAt)++;}
			// incrementando l1
			l1=u2+1;
		}
		for( i = l1 ; k < n ; i++ )
		{	VAux[k++] = pA->Positions[i]; (*NAt)++;}
		
		// copiando temp em x
		//for( i = 0 ; i < n ; i++)
		//	pA->Positions[i] = VAux[i];
		pVAux = VAux;
		VAux = pA->Positions;
		pA->Positions = pVAux;

		size*=2;
	}
	free(VAux);
}
