#include "StopWatch.h"

#ifdef _WIN32 //| _WIN64

void StartTimer(StopWatch *timer)
{
	QueryPerformanceCounter(&(timer->start));
}

void StopTimer(StopWatch *timer)
{
	QueryPerformanceCounter(&(timer->stop));
}

double LIToSecs(LARGE_INTEGER *L)
{
	LARGE_INTEGER frequency;
	QueryPerformanceFrequency(&frequency);
	return ((double)L->QuadPart/(double)frequency.QuadPart);
}

double GetElapsedTime(StopWatch *timer)
{
	LARGE_INTEGER time;
	time.QuadPart = timer->stop.QuadPart - timer->start.QuadPart;
	return LIToSecs(&time) ;
}

#else

void StartTimer(StopWatch *timer)
{
	clock_gettime(CLOCK_REALTIME, &(timer->start));
}

void StopTimer(StopWatch *timer)
{
		clock_gettime(CLOCK_REALTIME, &(timer->stop));
}

long double GetElapsedTime(StopWatch *timer)
{
	long double time;
	time = (timer->stop.tv_sec-timer->start.tv_sec) + (timer->stop.tv_nsec-timer->start.tv_nsec)/1000000000.;
	return time;
}

#endif
