#include "Sort.h"

int main()
{
	TArray A;
	StopWatch timer;
	int NAt = 0, NComp = 0;
	int size,toprint;
	int line;
	double elapsedTime;
	FILE *in, *log;

	char* input  = (char*)calloc(BUFSIZ,sizeof(char));
	char* output = (char*)calloc(BUFSIZ,sizeof(char));
	char* arg    = (char*)calloc(BUFSIZ,sizeof(char));
	char* arg2   = (char*)calloc(BUFSIZ,sizeof(char));

	Allocate(&A,1);

	in = fopen("in.txt","rt");
	if(in == NULL)
	{
		printf("File can't opened\n");
		exit(1);
	}
	log = fopen("log.txt","w");
	if(in == NULL)
	{
		printf("File can't opened\n");
		exit(1);
	}
	
	line = 1;
	fgets(input,BUFSIZ,in);
	input = strtok(input,"\n");
	if(!strcmp(input,"SortingInput.dat"))
		fputs("log.txt\n",log);
	else
	{
		fputs("File Invalid\n",log);
		printf("File Invalid\n");
		exit(1);
	}

	while(!feof(in))
	{
		NAt = 0;NComp = 0;
		char *pS=fgets(input,BUFSIZ,in);
		line++;
		if (pS == NULL) // invalid / NULL line
			continue;

		// Lendo o Tamanho
		arg = strtok(input,";");
		if(arg == NULL)
		{
			sprintf(output,"Line Invalid: %d; error: \"No value\"; Expected size of array in first argument!\n",line);
			fputs(output,log);
			continue;
		}
		size = atoi(arg);
		free(A.Positions);
		Allocate(&A,size);

		// Lendo o tipo de vetor
		arg = strtok(NULL,";");
		if(arg == NULL)
		{
			sprintf(output,"Line Invalid: %d; error: \"No value\"; Expected type of array in third argument!\n",line);
			fputs(output,log);
			continue;
		}



		if(!strcmp(arg,"sor"))
		{
			GenerateSorted(&A,size);
			sprintf(arg2,"Sorted;");
		}
		else if(!strcmp(arg,"ran"))
		{
			GenerateRandomNoRep(&A,size);
			sprintf(arg2,"Random;");
		}
		else if(!strcmp(arg,"als"))
		{
			GenerateAlmostSortedNoRep(&A,size);
			sprintf(arg2,"Almost Sorted;");
		}
		else if(!strcmp(arg,"inv"))
		{
			GenerateInvert(&A,size);
			sprintf(arg2,"Inverted;");
		}
		else 
		{
			sprintf(output,"Line Invalid: %d; error: \"%s\"; Expected type of array in second argument!\n",line,arg);
			fputs(output,log);
			continue;
		}

		// Lendo o tipo de impresso
		arg = strtok(NULL,";");
		if(arg == NULL)
		{
			sprintf(output,"Line Invalid: %d; error: \"No value\";Expected pri(print) or npr(not print) in third argument!\n",line);
			fputs(output,log);
			continue;
		}
		if(!strcmp(arg,"npr"))
			toprint = 0;
		else if(!strcmp(arg,"pri"))
			toprint = 1;
		else
		{
			sprintf(output,"Line Invalid: %d; Expected pri(print) or npr(not print) in third argument!\n",line);
			fputs(output,log);
			continue;
		}

		// Lendo o algoritmo de ordenao
		arg = strtok(NULL,"\n");
		if(arg == NULL)
		{
			sprintf(output,"Line Invalid: %d; error: \"No value\"; Expected symbol of ordenation method in last argument!\n",line);
			fputs(output,log);
			continue;
		}
		if(!strcmp(arg,"qui"))
		{
			if(toprint)
			{
				printf("Quicksort:\n");
				Print(&A);
			}
			StartTimer(&timer);
			QuickSort(&A,&NAt,&NComp);
			StopTimer(&timer);
			if(toprint)
				Print(&A);
			elapsedTime = GetElapsedTime(&timer);
			sprintf(arg,"Quicksort;");
		}
		else if(!strcmp(arg,"quio"))
		{
			if(toprint)
			{
				printf("QuicksortO:\n");
				Print(&A);
			}
			StartTimer(&timer);
			QuickSortO(&A,&NAt,&NComp);
			StopTimer(&timer);
			if(toprint)
				Print(&A);
			elapsedTime = GetElapsedTime(&timer);
			sprintf(arg,"QuicksortO;");
		}
		else if(!strcmp(arg,"hea"))
		{
			if(toprint)
			{
				printf("Heapsort:\n");
				Print(&A);
			}
			StartTimer(&timer);
			HeapSort(&A,&NAt,&NComp);
			StopTimer(&timer);
			if(toprint)
				Print(&A);
			elapsedTime = GetElapsedTime(&timer);
			sprintf(arg,"Heapsort;");
		}
		else if(!strcmp(arg,"heao"))
		{
			if(toprint)
			{
				printf("HeapsortO:\n");
				Print(&A);
			}
			StartTimer(&timer);
			HeapSortO(&A,&NAt,&NComp);
			StopTimer(&timer);
			if(toprint)
				Print(&A);
			elapsedTime = GetElapsedTime(&timer);
			sprintf(arg,"HeapsortO;");
		}
		else if(!strcmp(arg,"mer"))
		{
			if(toprint)
			{
				printf("Mergesort:\n");
				Print(&A);
			}
			StartTimer(&timer);
			MergeSort(&A,&NAt,&NComp);
			StopTimer(&timer);
			if(toprint)
				Print(&A);
			elapsedTime = GetElapsedTime(&timer);
			sprintf(arg,"Mergesort;");
		}
		else if(!strcmp(arg,"mero"))
		{
			if(toprint)
			{
				printf("MergesortO:\n");
				Print(&A);
			}
			StartTimer(&timer);
			MergeSortO(&A,&NAt,&NComp);
			StopTimer(&timer);
			if(toprint)
				Print(&A);
			elapsedTime = GetElapsedTime(&timer);
			sprintf(arg,"MergesortO;");
		}
		else
		{
			sprintf(output,"Line Invalid: %d; error: \"%s\"; Expected symbol of ordenation method in last argument!\n",line,arg);
			fputs(output,log);
			continue;
		}

		sprintf(output,"%-13s %-14s; %10d elements; Assignments: %10d; Comparisons: %10d; Elapsed time: %10.6lf;\n",arg,arg2,size,NAt,NComp,elapsedTime);
		fputs(output,log);
		// verifica se arquivo est ordenado - tempo no levado em conta
		int x;
		if ( (x=IsSorted(&A)) != -1 )
		{
			sprintf(output,"internal error - vector not sorted - position %d\n",x);
			fputs(output,log);
			exit(4);
		}

//		free(output);
//		output = (char*)calloc(BUFSIZ,sizeof(char));

		fflush(log);
	}
	fclose(log);
	return 0;
}
